function y = clipped_mean(x, lims)
% y = clipped_mean(x, lims)
% use to trim spikes out of the Hameg signal
% e.g.
% y = clipped_mean(v, [0.95 1.05])
% only uses values in the range 0.95*m to 1.05 * m
% where m is the unclipped mean
% RWM

if min(size(x))>1, error('Please use with vectors only'); end
nx = length(x);

mx = mean(x);
if mx<0, lims = flip(lims); end % easier tnan changing direction of <>
    
I = x>=(lims(1)*mx) & x<=(lims(2)*mx);
nI = sum(I);

if nI<0.999*nx,
    disp([sprintf('%0.1f', (1 - nI/nx)*100) '% of points have been removed'])
end

y = mean(x(I));
disp(['Mean changes by '   sprintf('%0.2f', (y/mx -1)*100) '%'])



