clear
c = 21;v = round(0.22*c):c;
% nb.  x & y-axes are non-dimensionalised i.e. multiples of s
load pyro3_p.mat p

%[X, Y, W, Wsum, lamps] = illumination3D(0.26, 1.73/0.26, [0.46 0.5  0.07 -0.5*pi 4], 0.13/0.26, 2*c-1, 11);
% 700*700 mm target area:
[X, Y, W, Wsum, ms1] = ...
            illumination3D_v3(0.35, 1.73/0.35, [0.19/0.35, 0.15/0.35,  -d2r(5.5) 0.5*pi 4], 0.2/0.35, 2*c-1, 11, p); % was .096
  
figure(5);
hs = surf(X,Y,Wsum);% axis([-1 1 -1 1 600 1250])
zlabel('Illumination (W/m^2)')
shading interp
set(hs, 'edgecolor','k')
xlabel('Non-dimensional position (x)')
ylabel('Non-dimensional position (y)')

%-----------------------------------------------------------------------

% summary for 470*470 mm target area:
alpha = -15:1:15;
refs = [0 1 2 3 4 5 11];
for j = 1:7
    for i = 1:length(alpha)
        [X, Y, W, Wsum, stdW(i, :, j)] = ...
            illumination3D_v3(0.35, 1.73/0.35, [0.19/0.35, 0.15/0.35,  d2r(alpha(i)) 0.5*pi 4], 0.2/0.35, 2*c-1, refs(j), p, 47/70); % was .096
        %                                       (s, n, ggabn,                               k, nx, max_reflections);
        %    illumination3D_v2(s, n, ggabn, k, nx, max_reflections, p)
        
    end
end

set(0, 'defaultlinelinewidth', 2)
lstyles = {':', '-.', '--', '-', '-', 'none'};
mstyles = {'none','none','none','none','none','o'};

figure(7)
subplot(1,2,1)
%yyaxis left
h6 = plot(alpha, squeeze(stdW(:,1,1:6))) %, '--', alpha, squeeze(stdW(:,1,2)), '-')
legend(cellstr(i2s(refs(1:6)')))
xlabel('Lamp tilt angle \alpha (\circ)')
ylabel('Mean illumination (W/m^2)')
axis([-15 15 0 1400])
grid

subplot(1,2,2)
h7 = plot(alpha, squeeze(stdW(:,2,1:6)./stdW(:,1,1:6))) %, '^', alpha, squeeze(stdW(:,2,2)),  'o')
legend(cellstr(i2s(refs(1:6)')))
xlabel('Lamp tilt angle \alpha (\circ)')
ylabel('Standard deviation / mean')
axis([-15 15 0 0.07])
grid

for i = 1:6
    set([h6(i) h7(i)], 'linestyle',lstyles{i}, 'marker', mstyles{i})
end

