function [cals, found] = readcals(calfile, gnams);
% use to get RTD etc calibrations from a file
% RWM

s = load(calfile);
nchans = size(gnams, 1);
if size(gnams, 2)>size(s.Gnam, 2),
    gnams = gnams(:, 1:size(s.Gnam, 2));
end  % else none will be found if you make up too long a name !!!

[found1, from2, minmaxf] = textfind(s.Gnam, gnams);
if minmaxf(2)>1, error('Transducer occurs more than once in calibration file'); end

cals = zeros(nchans, size(s.p,2));  % a row for each transducer
found = zeros(nchans,1);

cals(from2,:) = s.p(found1,:);
found(from2) = 1;
found = logical(found);

