function y = table_rm(tab, x, allowext);
% function y = table_rm(tab, x, allowext):  A fast replacement for table1.m
% This is a faster version of table1.m 
% (typically 4 to 12 * faster depending on array size).
% If nargin>2 it will extrapolate instead of complaining.
% Roger Moss 

% Written by Roger Moss, February 1994.

if size(x,2)>1, error('x must be a column vector'); end
lt=length(x); p = zeros(lt,1);
if ~lt, y = p; return; end
[r, c] =  size(tab);
if tab(1,1)>tab(2,1), tab = tab(r:-1:1,:);  end		% (flipud)

dn = diff(tab);
if any(dn(:,1)<0), error('Table column 1 is not monotonic'); end;

ds=0; if any(diff(x)<0), [x, I] = sort(x); ds=1; end
if nargin<3, if x(1)<tab(1,1) | x(lt)>tab(r,1), error('x not all within tab(:,1)'); end; end
n=2;

if nargin<3,
 for ix = 1:lt,
  while x(ix)>tab(n,1), n=n+1; end
  p(ix)=n;
 end
else
 for ix = 1:lt,
  while x(ix)>tab(n,1), n=n+1; 
   if n>r, n=r; break; end; 
  end
  p(ix)=n;
 end
end

f = (tab(p,1)-x)./dn(p-1,1);
f = f(:, ones(1,c-1));
y = tab(p,2:c) - (dn(p-1,2:c).*f);
if ds==1, y(I,:) = y; end
