% 170202a, glass temperature rise, F1, high vacuum, no fan.
% Farid 1


clear

ir_temps1  % "Think" this should come first - generates "pins" etc

% part = touchfld({'G','P','Tcol', 'Test', 'TM', 'Tmstar', 'VI',...
%     'comment','effy','fan','ifit', 'lamps', 'massflow', 'meanVI', 'nom_power', 'n1n2','t'});


[S, fp] = loadconv_f1('RWM170202a.mat');
%---------------------
% apply RTD datum corrections:
% RTDmean160609b =  0.0678   -0.0678   -0.0019   -3.0028
% mean of RTD5 & 7 is -1.5024 so add 1.5024 to outlet temperatures
S.mioT(:,2) = S.mioT(:,2) + 1.5024;
S.dT = S.mioT(:,2)-S.mioT(:,1);
S.Tcol = mean(S.mioT')'; 
%---------------------------------
panel_area = 0.47^2;
heatfluxm2 = fp.c * S.massflow .*S.dT / panel_area;

actime = S.time - S.time(1) - 19.692*60;
etime = S.time - S.time(1);
plot(actime/3600, S.mioT);xlabel('Time (hours)'); ylabel('mioT (deg C)'); 

plot(actime/60, S.Power(:,5));xlabel('Time (mins)'); ylabel('Power'); 

set(gcf, 'defaultlinelinewidth', 2)

im_times = [
-5.633
-3.600
0.600
16.333
19.000
25.000
26.000
30.000
32.000
49.750
50.283
50.800
51.800
52.817
53.817
55.000
57.883
59.167
60.800
62.500
64.800
65.883
68.800
69.800
%72.200 % after end of capture
%107.950
%109.533
];  % minutes after 4 pm i.e. same as actime
% IR photos taken at these times
ints = findel(im_times, actime/60);  % using minutes!
n_im = length(ints);
% take -5 to + 5 secs for mean
v = -10:10; TC207_9 = [];
for i = n_im:-1:1, TC207_9(i,:) = mean(S.ch(ints(i)+v, 8:9)); end

%====================================================================
ip = 1;
plot(t, T(:, pins), '-', t, mean(T(:, pins)')', '--', actime/60, S.ch(:,8 ), '-.')
legend([heads{pins}, {'Mean','TC'}])
grid

plot(t, mean(T(:, pins)')'-1, '-', actime/60, S.ch(:,8 ), '-.')
legend({'IR mean -1 \circC','TC'})
grid

% remove glitches?
% S.TC207 = correct(S.ch(:,8));
% S.TC209 = correct(S.ch(:,9));
%save test170202a.mat S
load test170202a.mat S

plot(t, T(:, pins(1))-1.1, actime/60, S.ch(:,8 ), '-.')
plot(t, T(:, pins)-1.2, actime/60, S.TC207, '-.')
legend({heads{pins},'TC'})
%legend([{[heads{pins(1)} '-1.1'], 'TC'}])
grid


plot(t, T(:, pins(1))-1.2, actime/60, S.TC207, '-.')
plot(actime/60, S.TC207, '-')
ints = findel([24.6 34.2 35.8 48.6 49.8 56.1], actime/60);
ints2 = findel([24.6 34.2 37.5 48.6 49.8 56.1], actime/60);
ints2 = findel([24.6 34.2 34.9 48.6 49.8 56.1], actime/60);

for ip = 1:3
    v = ints(2*ip-1):ints(2*ip);
    part(ip).t = actime(v)/60;
    ifit = ifit_fitting(part(ip).t, S.TC207(v), 'T','exp_abc');
    % allow TC209 part 2 to start later
    v = ints2(2*ip-1):ints2(2*ip);
    part(ip).t = actime(v)/60;
    if ip == 2 %2
      %ifit(2) = ifit_fitting(part(ip).t, S.TC209(v), 'T','poly2');        
      ifit(2) = ifit_fitting(part(ip).t, S.TC209(v), 'T','exp_abc', [15, -15, -0.02]); 
      %cf = fit(part(ip).t, S.TC209(v), 'exp1');
      %ifit(2).curve = cf;
    else
      ifit(2) = ifit_fitting(part(ip).t, S.TC209(v), 'T','exp_abc');
    end
    part(ip).ifit = ifit;
    axis([24 60 32 44])
end
%==========================================================
% Plot figure 10 for paper:
set(gcf, 'defaultlinelinewidth', 2)
h = plot(actime/60, [S.TC207 S.ch(:,7) S.Tcol-10 S.TC209 S.ch(:,6)], '-');
set(h(3), 'linestyle', '--')
hold on
for ip = 1:3, for i = 1:2 
        hii=plot(part(ip).ifit(i).curve); 
        set(hii, 'linewidth', 1)
end; end
axis([25 60 30 45])
grid

hold off

 ha = arrow;
 set(ha(1), 'color', get(h(3),'color'))
 set(ha(2),'edgecolor', get(h(3),'color'),'facecolor',get(h(3),'color'))
 legend({'Pillar top', 'Pillar bottom', 'Absorber mean - 10\circC','Distant from pillars (top)',...
    'Distant from pillars (bottom)' 'Exponential fits'})
xlabel('Time (minutes)'); ylabel('Temperatures (\circC)')
%===================================================
% determine heating rate at t = 34.2 minutes: for central TC (2)
% t_ch = actime(ints(2))/60;
% 
% for i = 1:2
%     cf = part(i).ifit(2).curve;
%     c = cf.c;
%     dTdt(i) = cf.b * c * exp(-c*t_ch);
% end
% d = [0.004 0.0009 0.004]';
% rho = [2480 8960 2480]';
% c = [990 380 990]';
% 
% qdot = d(1)*rho(1)*c(1)*diff(dTdt)/60
% 
% 
% ip = 1;
% part(ip).Test = '170202a';
% part(ip).fan = 1;
% plot(actime/60, heatfluxm2);
% xlabel('Time (min)'); ylabel('Heat flux (W/m^2)')
% 
% plot(etime/3600, heatfluxm2);
% part(ip).n1n2 = [2244 3220];
% n = part(ip).n1n2(1) : part(ip).n1n2(2);
% part(ip).P = mean(S.p(n));
% part(ip).Tcol = mean(S.Tcol(n));
% part(ip).t = S.time(n)-S.time(n(1));
% part(ip).massflow = S.massflow(n); 
% part(ip).nom_power = 1277;
% 
% plot(actime(n)/60, S.Power(n,:));  
% part(ip).VI = S.Power(n,5); 
% part(ip).meanVI = clipped_mean(part(ip).VI, [0.95 1.05]);
% disp(['Mean power = ', num2str(part(ip).meanVI) ])
% 
% subplot(4,1,1)
% ifit = ifit_fitting(part(ip).t, heatfluxm2(n), 'Q','exp_abc');
% subplot(4,1,2)  
% ifit(2) = ifit_fitting(part(ip).t, S.Tam(n), 'Tam','exp_abc');
% subplot(4,1,3)
% ifit(3) = ifit_fitting(part(ip).t, S.T_top(n,1), 'T_top1','poly1'); 
% subplot(4,1,4)
% ifit(4) = ifit_fitting(part(ip).t, S.T_bottom(n,1), 'T_bottom1','poly1');  
% part(ip).ifit = ifit;
% 
% 
% part(ip).lamps = '1234';
% part(ip).G = lamp_settings(part(ip).lamps, part(ip).meanVI);
% part(ip).TM = ifit(2).final_vs(1);
% part(ip).effy = ifit(1).final_vs(1) / part(ip).G;  
% part(ip).Tmstar = part(ip).TM / part(ip).G;   
% part(ip).comment = '18 degree delta T';
 


