function W = v2power(v, range)
% W = v2power(v, range)
% this converts the voltage recorded by the A/D system into the electrical
% power supplied to the lights.
%
% Call with one argument to see the power possibilities or
% with two arguments e.g. v2power(0.3, 2) to get the second in this list.
% If V is a column vector, W will have 5 columns unless you specify
% "range".
% RWM

load('fw_rect2.mat', 'hm115_coeffs')

W = zeros(length(v), 5);
for i = 1:5,
   W(:,i) = polyval(hm115_coeffs(i,:), v);
end

if nargin>1,
    W = W(:, range);
elseif length(v)==1
    disp('Electrical power possibilities are:')
    disp(W)
end

